' -------------------------------------------------------------------------------------------
'                           Copyright Christopher R. Boss, 2000
'                                  Alls Rights Reserved
'                           This code may be used ROYALTY FREE !
'                           You may use this code in any commercial application
'                           freely. You may also distribute the code to others
'                           and may post it on a web site for others to use,
'                           as long as the copyright is left in the code.
' -------------------------------------------------------------------------------------------

#DIM ALL
#DEBUG ERROR OFF
#COMPILE DLL
#INCLUDE "win32api.inc"

' -------------------------------------------------------------------------------------------
'                          Custom Class ControlClass Constants and Types
' -------------------------------------------------------------------------------------------
%ControlClassExtraData       = 5     ' # of Extra Data Items (Long) for All Custom Window Classes
                                ' Data Items will be indexed from 1 in GetControlData function
' -------------------------------------------------------------------------------------------
$ControlClassName            = "MY_CUSTOM_CTRL1"
' -------------------------------------------------------------------------------------------



' -------------------------------------------------------------------------------------------
'                              Universal Global Variables
' -------------------------------------------------------------------------------------------
GLOBAL DLL_Instance&

' -------------------------------------------------------------------------------------------
'                           EZGUI Custom Control Library Declares
' -------------------------------------------------------------------------------------------
DECLARE FUNCTION GetControlLong(BYVAL hWnd AS LONG, BYVAL N&) AS LONG
DECLARE SUB SetControlLong(BYVAL hWnd AS LONG, BYVAL N&, BYVAL V&)


' -------------------------------------------------------------------------------------------
'                           Custom Control Control Class Declares
' -------------------------------------------------------------------------------------------
DECLARE SUB RegisterControlClass()
DECLARE SUB ControlClassPaint(BYVAL hWnd AS LONG)
DECLARE SUB ControlClassDraw(BYVAL hWnd AS LONG)
DECLARE SUB BuildBitmap(BYVAL hWnd AS LONG, BYVAL CFlag&)

' -------------------------------------------------------------------------------------------
' -------------------------------------------------------------------------------------------

%MY_CUSTOM_MESSAGE      =   %WM_USER+100

' -------------------------------------------------------------------------------------------
'                              DLL Entrance - LibMain
' -------------------------------------------------------------------------------------------

FUNCTION LIBMAIN(BYVAL hInstance   AS LONG, _
                 BYVAL fwdReason   AS LONG, _
                 BYVAL lpvReserved AS LONG) EXPORT AS LONG
    SELECT CASE fwdReason
        CASE %DLL_PROCESS_ATTACH    ' =1 - Where DLL starts
            DLL_Instance&=hInstance
            RegisterControlClass
        CASE %DLL_THREAD_ATTACH
        CASE %DLL_THREAD_DETACH
        CASE %DLL_PROCESS_DETACH    ' =0 - Where DLL exits
        CASE ELSE
    END SELECT
    LIBMAIN=1
END FUNCTION


' -------------------------------------------------------------------------------------------
'                          Custom Control ControlClass Functions / Subs
' -------------------------------------------------------------------------------------------
SUB RegisterControlClass()
LOCAL windowclass    AS WndClassEx
LOCAL szClassName AS ASCIIZ * 80
    szClassName            = $ControlClassName+CHR$(0)
    windowclass.cbSize        = SIZEOF(windowclass)
    windowclass.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_PARENTDC OR %CS_DBLCLKS OR %CS_GLOBALCLASS
    windowclass.lpfnWndProc   = CODEPTR(ControlClassWndProc)
    windowclass.cbClsExtra    = 0
    windowclass.cbWndExtra    = %ControlClassExtraData*4
    windowclass.hInstance     = DLL_Instance&
    windowclass.hIcon         = %NULL
    windowclass.hCursor       = LoadCursor( %NULL, BYVAL %IDC_ARROW )
    windowclass.hbrBackground = GetStockObject( %WHITE_BRUSH )
    windowclass.lpszMenuName  = %NULL
    windowclass.lpszClassName = VARPTR( szClassName )
    windowclass.hIconSm       = %NULL
    RegisterClassEx windowclass
END SUB

' -------------------------------------------------------------------------------------------

FUNCTION ControlClassWndProc(BYVAL hWnd   AS LONG, _
                 BYVAL Msg    AS LONG, _
                 BYVAL wParam AS LONG, _
                 BYVAL lParam AS LONG) EXPORT AS LONG

LOCAL RV&, hParent AS LONG

'  If message is processed then set FUNCTION=0 and then EXIT FUNCTION

SELECT CASE Msg
     CASE %MY_CUSTOM_MESSAGE
        ' New Control Color passed in wParam
        ' You could pass almost any type of info about your control using
        ' this technique. Even a pointer to a complex UDT could be passed.
        ' A single Long value representing a RGB color is just an example
        ' used for this sample project.
        SetControlLong hWnd, 5, wParam
        ControlClassDraw hWnd
        InvalidateRect hWnd, BYVAL %NULL, %TRUE
        FUNCTION=RV&
        EXIT FUNCTION
    CASE %WM_PAINT
        ControlClassPaint hWnd
        FUNCTION=0
        EXIT FUNCTION
    CASE %WM_ERASEBKGND
        FUNCTION=0
        EXIT FUNCTION
    ' -----------------------------------------------------------
    CASE %WM_SETCURSOR
    CASE %WM_LBUTTONDBLCLK
        hParent=GetParent(hWnd)
        IF hParent<>0 THEN
            ' Uses the Standard Static control message
            SendMessage hParent, %WM_COMMAND, MAKLNG(GetWindowLong(hWnd,%GWL_ID),%STN_DBLCLK), hWnd
        END IF
    CASE %WM_LBUTTONDOWN
        hParent=GetParent(hWnd)
        IF hParent<>0 THEN
            ' Uses the Standard Static control message
            SendMessage hParent, %WM_COMMAND,MAKLNG(GetWindowLong(hWnd,%GWL_ID),%STN_CLICKED), hWnd
        END IF
    CASE %WM_ENABLE

    CASE %WM_GETDLGCODE

    CASE %WM_CREATE
        ' --------------------------------------
        ' Set Default Color
        SetControlLong hWnd, 5, RGB(255,255,0)
        ' Set any Default values for control here
        ' --------------------------------------
        BuildBitmap hWnd, 1
    CASE %WM_DESTROY
        BuildBitmap hWnd, -1
    CASE %WM_SIZE
        BuildBitmap hWnd, 0
        ' ControlClassDraw hWnd
        InvalidateRect hWnd, BYVAL %NULL, %TRUE
    CASE ELSE
END SELECT

FUNCTION = DefWindowProc(hWnd,Msg,wParam,lParam)

END FUNCTION

' -------------------------------------------------------------------------------------------

SUB BuildBitmap(BYVAL hWnd AS LONG, BYVAL CFlag&)
LOCAL R AS RECT, hDC AS LONG, hBmp AS LONG, hDC2 AS LONG
LOCAL hOldBmp AS LONG, W&, H&
' CFlag&=1 for Creation, =0 for Resize, -1 for destroy
IF CFlag&<=0 THEN
    ' Delete Previous DC and Bitmap
    hDC=GetControlLong(hWnd, 1)
    hBmp=GetControlLong(hWnd, 2)
    DeleteObject hBmp
    DeleteDC hDC
    SetControlLong hWnd, 1, 0
    SetControlLong hWnd, 2, 0
    SetControlLong hWnd, 3, 0
    SetControlLong hWnd, 4, 0
END IF
IF CFlag&>=0 THEN
    hDC2=GetDC(hWnd)
    hDC=CreateCompatibleDC(hDC2)
    GetClientRect hWnd, R
    W&=R.nRight-R.nLeft
    H&=R.nBottom-R.nTop
    hBmp=CreateCompatibleBitmap(hDC2, W&, H&)
    SelectObject hDC, hBmp
    ReleaseDC hWnd, hDC2
    SetControlLong hWnd, 1, hDC
    SetControlLong hWnd, 2, hBmp
    SetControlLong hWnd, 3, W&
    SetControlLong hWnd, 4, H&
    ControlClassDraw hWnd
END IF
END SUB

' -------------------------------------------------------------------------------------------

SUB ControlClassDraw(BYVAL hWnd AS LONG)
LOCAL hDC AS LONG, W&, H&, L&, ATL&, tbuffer$, CFlag&
LOCAL hParent AS LONG, hBrush AS LONG, OldhBrush AS LONG, C&
IF IsWindow(hWnd) THEN
    hDC=GetControlLong(hWnd, 1)
    W&=GetControlLong(hWnd, 3)
    H&=GetControlLong(hWnd, 4)
    C&=GetControlLong(hWnd, 5)
    '  ------------------------------------
    '  Draw your control here into the memory DC (not the window DC).
    '  The memory DC has a Bitamp associated with it already.
    '  The code below is just sample code.
    '  ------------------------------------

    ' In this example lParam is simply an RGB color value
    hBrush=CreateSolidBrush(C&)
    OldhBrush=SelectObject(hDC, hBrush)
    PatBlt hDC, 0,0, W&, H&, %PATCOPY
    SelectObject hDC, OldhBrush
    DeleteObject hBrush
END IF
END SUB

' -------------------------------------------------------------------------------------------

SUB ControlClassPaint(BYVAL hWnd AS LONG)
LOCAL PS AS PAINTSTRUCT
LOCAL hDC AS LONG, R AS RECT, tbuffer$, L&, ATL&
LOCAL memDC AS LONG
' TYPE PAINTSTRUCT
'   hdc AS LONG
'   fErase AS LONG
'   rcPaint AS Rect
'   fRestore AS LONG
'   fIncUpdate AS LONG
'   rgbReserved(1 TO 32) AS BYTE
' END TYPE
    IF IsWindow(hWnd) THEN
        hDC=BeginPaint(hWnd, PS)
        memDC=GetControlLong(hWnd, 1)
        ' ------------------------------------------------
        BitBlt hDC, PS.rcPaint.nLeft, PS.rcPaint.nTop, _
                    PS.rcPaint.nRight-PS.rcPaint.nLeft, PS.rcPaint.nBottom-PS.rcPaint.nTop, _
                    memDC, PS.rcPaint.nLeft, PS.rcPaint.nTop, %SRCCOPY
        EndPaint hWnd, PS
    END IF
END SUB

' -------------------------------------------------------------------------------------------






' -------------------------------------------------------------------------------------------
'                             EZGUI Custom Control Library
' -------------------------------------------------------------------------------------------

FUNCTION GetControlLong(BYVAL hWnd AS LONG, BYVAL N&) AS LONG
LOCAL I&, RV&
RV&=0
IF N&>=1 AND N&<=%ControlClassExtraData THEN
    I&=(N&-1)*4
    IF IsWindow(hWnd) THEN
        RV&=GetWindowLong(hWnd, I&)
    END IF
END IF
FUNCTION=RV&
END FUNCTION

' -------------------------------------------------------------------------------------------

SUB SetControlLong(BYVAL hWnd AS LONG, BYVAL N&, BYVAL V&)
LOCAL I&
IF N&>=1 AND N&<=%ControlClassExtraData THEN
    I&=(N&-1)*4
    IF IsWindow(hWnd) THEN
        SetWindowLong hWnd, I&, V&
    END IF
END IF
END SUB

' -------------------------------------------------------------------------------------------
